#include "DataFlash.h"
#ifndef _MSC_VER
#include <string.h>
#endif
#include <memory.h>

CDataFlash::CDataFlash()
{
	m_mem = new unsigned char[DATAFLASH_V3_SIZE];
	m_memUse = new unsigned int[DATAFLASH_V3_SIZE / 32];
	Reset();
}

CDataFlash::~CDataFlash()
{
	delete[] m_mem;
	delete[] m_memUse;
}

void CDataFlash::Reset()
{
	// Basisadresse auf 0 setzen
	m_baseAddress = 0;
	// Speicher initialisieren
	memset(m_mem, 0xFF, DATAFLASH_V3_SIZE);
	memset(m_memUse, 0, (DATAFLASH_V3_SIZE / 32) * sizeof(unsigned int));
}

void CDataFlash::SetMemUsebit(unsigned int address)
{
	address -= m_baseAddress;
	m_memUse[address / 32] |= (1 << (address % 32));
}

unsigned char CDataFlash::GetMemUsebit(unsigned int address)
{
	address -= m_baseAddress;
	return (m_memUse[address / 32] & (1 << (address % 32))) ? 1 : 0;
}

unsigned int CDataFlash::GetMemFirstAddress()
{
	unsigned int address, firstAddress =  m_baseAddress;
	for (address=0; address < DATAFLASH_V3_SIZE; address++) {

		if (GetMemUsebit(address + m_baseAddress)) {

			firstAddress = address + m_baseAddress;
			break;
		}
	}

	return firstAddress;
}

unsigned int CDataFlash::GetMemLastAddress()
{
	unsigned int address, lastAddress = m_baseAddress;
	for (address=0; address < DATAFLASH_V3_SIZE; address++) {

		if (GetMemUsebit(address + m_baseAddress)) {

			lastAddress = address + m_baseAddress;
		}
	}

	return lastAddress;
}
