// DFItemHandling.cpp: Implementierung der Klasse CDFItemHandling.
//
//////////////////////////////////////////////////////////////////////

#include "DFItemHandling.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemHandling::CDFItemHandling( NodeTypeID _type ) : CDFItemBase( _type )
{

}

CDFItemHandling::~CDFItemHandling()
{

}

int CDFItemHandling::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChild;
    StructBedien bedien;
    CDFItemBase *item = nullptr;

    // Daten von Konfig Root einlesen
    StructKonfigRoot &root = *(StructKonfigRoot*)&modifyData.file->m_flash[modifyData.offsFlash - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char*)&root.P );
    offs += sizeof(StructKonfigRoot);

    // Daten aller Eintraege einlesen
    for ( i = 0; i < (int)root.EintragCnt; ++i )
    {
        // Pointer des Eintrags berechnen
        offsChild = root.P + i * sizeof(unsigned int);	

        offsChild = *(unsigned int*)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];
        ChangeOrderLong( (unsigned char*)&offsChild );

        // Daten von Bedien - Struktur fuer Klassenerzeugung einlesen
        bedien = *(StructBedien*)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];

        switch ( bedien.Typ )
        {
            case TB_MENUE:
            { 
                item = new CDFItemMenu();
                break;
            }

            case TB_DATENSATZ:
            {
                item = new CDFItemInputChain();
                break;
            }

            default:
                break;
        }

        LinkEndChild( item );
        modifyData.offsFlash = offsChild;
        item->Modify( modifyData );
    }

    // Adresse zurueckkonvertieren
    ChangeOrderLong( (unsigned char*)&root.P );

    return 1;
}
